// > sort 2
const jprint = console.log;

const JS_RED = "\x1b[31m";
const JS_GREEN = "\x1b[32m";
const JS_YELLOW = "\x1b[33m";
const JS_BLUE = "\x1b[34m";
const JS_PURPLE = "\x1b[35m";
const JS_CYAN = "\x1b[36m";
const JS_WHITE = "\x1b[37m";
const JS_GRAY = "\x1b[90m";
const JS_RESET = "\x1b[0m";
const BG_RED = "\x1b[41m";
const BG_GREEN = "\x1b[42m";
const BG_YELLOW = "\x1b[43m";
const BG_BLUE = "\x1b[44m";
const BG_PURPLE = "\x1b[45m";
const BG_CYAN = "\x1b[46m";
const BG_WHITE = "\x1b[47m";
const BG_GRAY = "\x1b[100m";
const BG_RESET = "\x1b[0m";

var ARENA_NAME = arenaInfo["name"];
var ARENA_LEVEL = arenaInfo["level"];
var ARENA_SEASON = arenaInfo["season"];
var ARENA_TICKS_LIMIT = arenaInfo["ticksLimit"];
var ARENA_CPU_TIME_LIMIT = arenaInfo["cpuTimeLimit"];
var ARENA_CPU_TIME_LIMIT_FIRST_TICK = arenaInfo["cpuTimeLimitFirstTick"];
const UsrObject =  __class__ ('UsrObject', [object], {
	__module__: __name__,
});

const IGNORE_SWAMP = UsrObject();
IGNORE_SWAMP.swampCost = 2;

const GlobalKnowledge =  __class__ ('GlobalKnowledge', [object], {
	__module__: __name__,
    now: 0,
	enemies: [],
	friends: [],
	battles: {
		enemies: [],
		friends: [],
	},
	civilian: {
		enemies: [],
		friends: [],
	},
	update_: function (k) {
		// console.log("GlobalKnowledge update_");
		k.now = get.ticks();
		k.enemies = get.creeps(st.enemy);
		k.friends = get.creeps(st.friend);
		k.battles.enemies  = get.filter(k.enemies, c=> st.atkable(c) || st.healable(c));
		k.battles.friends  = get.filter(k.friends, c=> st.atkable(c) || st.healable(c));
		k.civilian.enemies = get.filter(k.enemies, c=> !st.atkable(c) && !st.healable(c));
		k.civilian.friends = get.filter(k.friends, c=> !st.atkable(c) && !st.healable(c));
	},
});
const know = GlobalKnowledge();

const Point =  __class__ ('Point', [object], {
	__module__: __name__,
	exists: true,
	get __init__ () {return __get__ (this, function (self, x, y) {
		self.x = x;
		self.y = y;
	});},

	center: function (...points) {
		var length = len(points);
		if (length === 0) {
			return Point(0, 0);
		}
		var x_sum = 0, y_sum = 0;
		for (const p of points) {
			x_sum += p.x;
			y_sum += p.y;
		}
		return Point(math.floor(x_sum / length), math.floor(y_sum / length));
	},
	get __str__ () {return __get__ (this, function (self) {
		return 'Point(' + self.x + ', ' + self.y + ')';
	});},
});

var P = Point;

function is_at(p0, p1) {
	return p0.x === p1.x && p0.y === p1.y;
}

function not_at(p0, p1) {
	return p0.x !== p1.x || p0.y !== p1.y;
}
const std =  {
	__expand_composite_as_list__:function (filter_composite) {
		var tmp = [];
		if (isinstance (filter_composite, tuple ([tuple, list]))) {
			for (var each of filter_composite) 
				tmp.extend (std.__expand_composite_as_list__ (each));
			return tmp;
		}
		if (isinstance (filter_composite, set)) 
			return std.__expand_composite_as_list__ (py_next (py_iter (filter_composite)));
		return [filter_composite];
	},
	__generate_combo_js_eval__:function (filter_composite, fid) {
		if (isinstance (filter_composite, list)) {
			return ('(' + ' || '.join ((function () {
				var __accu0__ = [];
				for (var each of filter_composite) {
					__accu0__.append (std.__generate_combo_js_eval__ (each, fid));
				}
				return py_iter (__accu0__);
			}) ())) + ')';
		}
		if (isinstance (filter_composite, tuple)) {
			return ('(' + ' && '.join ((function () {
				var __accu0__ = [];
				for (var each of filter_composite) {
					__accu0__.append (std.__generate_combo_js_eval__ (each, fid));
				}
				return py_iter (__accu0__);
			}) ())) + ')';
		}
		if (isinstance (filter_composite, set)) 
			return (' !(' + std.__generate_combo_js_eval__ (py_next (py_iter (filter_composite)), fid)) + ')';
		return ('%' + fid [filter_composite]) + '%';
		
	},
	__expand_memory__: dict ({}),
	combo:function (filter_composite) {
		const memory_key = str(filter_composite);
		const fn = std.__expand_memory__.py_get(memory_key, null);
		if (fn) return fn;
		const fn_ids = dict({});
		const id_fns = dict({});
		const _ = std.__expand_composite_as_list__(filter_composite);
		for (var [f_id, each_fn] of enumerate (set (_))) {
			f_id++;
			fn_ids [each_fn] = f_id;
			id_fns [f_id] = each_fn;
		}
		var _eval_str = std.__generate_combo_js_eval__ (filter_composite, fn_ids);
		var _inner = function (obj) {
			var eval_str = _eval_str + '';
			for (var [fn_id, func] of id_fns.py_items ()) {
				eval_str = eval_str.replace('%' + fn_id + '%', String(!!func(obj)));
				// pass;
			}
			return eval (eval_str);
		};
		std.__expand_memory__ [memory_key] = _inner;
		return _inner;
	},
	log:function (caller_name, ...args) {
		console.log("[" + caller_name, " [33m" + "Log" + "[0m" + "]:", ...args)
	},
	info:function (caller_name, ...args) {
		console.log("[" + caller_name, " [42m" + "Info" + "[0m" + "]:", ...args)
	},
	warn:function (caller_name, ...args) {
		console.log("[" + caller_name, " [43m" + "Warn" + "[0m" + "]:", ...args)
	},
	error:function (caller_name, ...args) {
		throw new Error("[" + caller_name + " [41m" + "Warn" + "[0m" + "]: " + args.join(" "))
	},
	__show_usage_flag__: false,
	__cpu_limit__: Math.floor (ARENA_CPU_TIME_LIMIT / 1000),
	__cpu_first_limit__: Math.floor (ARENA_CPU_TIME_LIMIT_FIRST_TICK / 1000000),
	show_usage: function () {
		const game_tick = get.ticks();

		// 如果尚未显示使用信息，则进行显示
		if (!(std.__show_usage_flag__)) {
			// 如果游戏周期至少为1，则设置标志以防止重复显示
			if (game_tick >= 1) std.__show_usage_flag__ = true;

			// 获取当前竞技场的信息
			const info = get.arena();
			const arena_name = info.py_name.__getslice__(0, 2, 1).lower();

			// 根据不同的竞技场名称，调整背景颜色
			var bg_color = '\x1b[48;2;45;45;45m';
			if (arena_name === 'sp') bg_color = '\x1b[48;2;45;64;39m';
			else if (arena_name === 'ca') bg_color = '\x1b[48;2;38;50;80m';
			else if (arena_name === 'co') bg_color = '\x1b[48;2;70;46;31m';

			// 根据语言设置，打印欢迎信息
			if (LANGUAGE === 'cn') {
				console.log(bg_color + '---------- 欢迎来到' + '\x1b[1m\x1b[38;2;205;85;85mScreeps \x1b[38;2;65;105;225mArena\x1b[22m' + '\x1b[37m' + '! ----------' + '\x1b[0m');
				console.log('工具库版本: ' + __VERSION__ + ', Python版本: ' + __PYTHON_VERSION__, '\n');
			} else {
				console.log(bg_color + '---------- Welcome to ' + '\x1b[1m\x1b[38;2;205;85;85mScreeps \x1b[38;2;65;105;225mArena\x1b[22m' + '\x1b[37m' + '! ----------' + '\x1b[0m');
				console.log('Package Version: ' + __VERSION__ + ', Python Version: ' + __PYTHON_VERSION__, '\n');
			}
		}

		// 根据语言设置，打印硬件使用情况的标题
		if (LANGUAGE === 'cn') console.log('[性能使用情况]');
		else console.log('[Hardware Usage]');

		// 显示CPU使用情况
		if (game_tick <= 1) {
			var v = round(get.cpu() / 1000000);
			var color = (v < 800 ? (v < 600 ? '\x1b[32m' : '\x1b[33m') : '\x1b[31m');
			console.log('cpu: ' + (color + v.toString()) + '\x1b[0m' + ' ms / {} ms'.format(std.__cpu_first_limit__));
		} else {
			var v = round(get.cpu() / 1000);
			var color = (v < 75000 ? (v < 50000 ? '\x1b[32m' : '\x1b[33m') : '\x1b[31m');
			console.log('cpu: ' + (color + v.toString()) + '\x1b[0m' + ' us / {} us'.format(std.__cpu_limit__));
		}

		// 显示内存使用情况
		const heap = get.heap();
		var v = round(heap.used_heap_size / 1024);
		var v_limit = round(heap.heap_size_limit / 1024);
		var color = (v < v_limit * 0.6 ? '\x1b[32m' : (v < v_limit * 0.8 ? '\x1b[33m' : '\x1b[31m'));
		if (LANGUAGE === 'cn') {
			console.log('内存: ' + (color + v.toString()) + '\x1b[0m' + ' KB / ' + v_limit + ' KB');
		} else {
			console.log('heap: ' + (color + v.toString()) + '\x1b[0m' + ' KB / ' + v_limit + ' KB');
		}
	},
}